//04/02/2013 
// Remplacement terminal COM1 par Terminal COM8 via bluetooth click RN-41 sur UART1 19200bds
// RC6 -- 750 -- TX BlueTooth RN41  ))) BlueSoleil -- ecran terminal COM8 sur service comm A
// RC7 <- 750 -- RX BlueTooth RN41  ((( BlueSoleil -- clavier terminal COM8 sur service comm A
//
//03/02/2013
// MAJ MPLAB => vers 8.89
//02/02/2013
// Rajout RTC DS1302
// Init par defaut de RTC si RE0=1 sinon reste sur l'heure RTC courante memeoriee par Ubatt 3,6V
// MAJ RTC via clavier Com1 UART1 38400 bds
// EDF inf siule part COM2 -> optocoupleur -> 74HCT132 -> sur UART2 1200,E,7,1
// test qualite EDFinfo : taux d'erruer toutes les 100 trames si input RA5 a zero
// usage de l'oscillateur interne 16MHz
//
// 26.01.2013
// rajout DS1302 RTC ..bugu
// test avec oscillateur 16MHZ interne PIC 
// coupleur 6N138 sur info EDF + trigger 2 etages 74HCT132 (pas d'inversion) -> D7
// 22 janv 2013
// Test avec PC
// COM2 simule le compteur EDF  
// terminal Com2 envoi soit un fichier TRAME.txt (qui contient STX au debut et EOT en fin)
// modifi via D:\outils\XE.EXE, ou via le script ../common/Vbray_teleinfo_trame.tsc
// Tx sur RC6 --3-DS275-5----3 HE10 --DB9M--DB9F-------- PC com1 19200,8,1,N 
// Rx sur RD7 --1-DS275-7----3 HE10 --DB9M--F/F--DB9M -- PC com2 1200,8,1,N 
// renvoi le contenu a exploiter sur com1 Ecran terminal et aussi sur BlueToothclick RX:
// Etat pompe, etat chauff, TInt,Text,KWH et Intensite 
//
// PICKIT3 bleu clair sur RB7  bleu Fce sur RB7   jaune sur MCLR  Blanc sur 0V
//
// PB: impossible d'activer UART2 Hardware  sur B7=RX B6=TX
// http://www.mikroe.com/forum/viewtopic.php?f=44&t=44929
// EasyLV-18f EUSART interrupt for PIC18F46K22
// According to the datasheet of the 18F46K22 (page 9),
// UART pins are located on RC6, RC7 (UART1) and RD6,RD7 (UART2) :
// effectivement c'est PORTB B7 B6 sur le 18F25K22 !! mais D7 D6 sur le 46k22
//
// Activation UART #2 pour teleinfo 1200,E,7,1
// on reste sur 8 bits car la parit est dans le mot de 8 bits !
// donc pas d'activation 9em bit pour la parit
// UART1 reste connect au PC pour debugging et affichage resultats
//
// Project name:
//	Project : 	    18F46K22_EDFinfo_BT_2013.mcp
//	main Source	:   18F46K22_EDFinfo_BT_130202.c
//  MCU:             PIC18F46K22
//  Dev.Board:       Own breadboard
//  Oscillator:      interne NO PLL used
//  Ext. Modules:    Bluetooth click Board -           ac:BT_click
//                   2x16 Lcd character display - ac:Lcd
//  Software:   
//          MPLAB IDE 8.89.00     
//          MPLAB C18 C18 V3.44
// buid option MPLAB C18 :
//  use alternative -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa- -nw=2054 -pa=3 -nw=2066 
//
//		    Pickit3 RS:01.15.06 AP:01.13.03-05  JAM Version: 01.27.04-05
//		    Terminal VBray
//		    Archos Side : RFO Basic
//  NOTES:
//     - Attention  Bluetooth click board sous 3,3V !
//   



#include "p18f46k22.h"

#include "stdio.h"
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <adc.h>
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>
#include <../_common/RTC_DS1302_.h>
#include <../_common/BlueTooth_.h>
 
//inclure  lectuart.O dans le projet object files si usage 8bits + parite..



// ====== hardware ===========
// voir 18F46k22_EDFinfo_Hardware.h
//
// config dans le code
// voir Help
//  Topics
//        Pic18 
//            config bits settings
//                    choisir PIC18F46K22
#define OSCILLATEUR_INTERNE

#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSHP, PLLCFG=OFF, PRICLKEN=ON ,FCMEN=OFF      
#endif    
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1        
#pragma config PBADEN=OFF,CCP3MX=PORTE0,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF            // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                  // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF        // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                    // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF    // CONFIG7L
#pragma config EBTRB = OFF                                           // CONFIG7H
// config vue par pickit3 2200 3C19 9900 0084 C00F E00F 400F


#ifndef Byte
#define Byte unsigned char
#endif
#ifndef Word
#define Word unsigned int
#endif

#ifndef DS1302_PINS
#define DS1302_PINS
#define IO_W     LATCbits.LATC4
#define IO_R     PORTCbits.RC4
#define TrisIO   TRISCbits.TRISC4
#define CS       LATCbits.LATC5
#define SCLK     LATCbits.LATC3
#endif


//#define LCD2x16

#ifdef LCD2x16
// DATA_PORT defines the port to which the LCD data lines are connected 
#define LCD_DATAPORT       PORTB
#define LCD_DATAPORT_TRIS  TRISB
//CTRL_PORT defines the port where the control lines are connected.
//ReadWrite Pin
#define LCD_RWPIN       PORTCbits.RC3
#define LCD_RWPIN_TRIS  TRISCbits.TRISC3
//RS Pin
#define LCD_RSPIN       PORTCbits.RC4
#define LCD_RSPIN_TRIS  TRISCbits.TRISC4
//Enable Pin
#define LCD_ENPIN       PORTCbits.RC5
#define LCD_ENPIN_TRIS  TRISCbits.TRISC5
// Lcd module connections

#include "../_common/LCD2x16.h"

#define LCD_L1home()    LCD_Cde(0x80)
#define LCD_L2home()    LCD_Cde(0xC0)
#define LCD_Clear()     LCD_Cde(0x01)
#define LCD_ReturnHome() LCD_Cde(0x02)
void LCD_Init(void);                            //to initialise the LCD
void LCD_Put(char data);                        //to put dtat to be displayed
void LCD_PutRamString(char *string);            //to display data string in RAM
void LCD_PutRomString(rom char *string);        //to display data stringin ROM
//char LCDIsBusy(void);                         //to check Busy flag
void LCD_Cde(unsigned char cmd);                //to send commands to LCD
//unsigned char LCDGetAddr(void);
//char LCDGet(void);
void Pulse_E (void);
void LCD_Pos(char L,char posX);
void LCD_Erase_Ligne(char L1);
void LCD_Delay15ms(void);
void LCD_Delay4ms(void);
void LCD_Delay100us(void);
void LCD_Delay500ns(void);
void LCD_Delay(void);
void SetCGRamAddr(unsigned char CGaddr);

#endif  //LCD2x16


#define CLS 12
#define BS 8
#define TAB 9
#define CR 13
#define LF 10
#define BELL 7
#define STX 0x02
#define EOT 0x03

#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1


#define Pompe PORTAbits.RA2
#define Chauffage PORTAbits.RA3
#define Led_Rouge LATAbits.LATA4
#define Quality_link_test PORTAbits.RA5
#define Force_RTC PORTEbits.RE0


// responses to parse
#define BT_CMD 1
#define BT_AOK 2
#define BT_CONN 3
#define BT_END 4


#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;

rom const char chaine0[]="...";
rom const char chaine1[]="Port Hard UART1 19200,N,8,1 (RC6 RC7_ -> BT RN41 \r\n";
rom const char chaine2[]="Port Hard UART2 EDF info 1200,E,N,7,1 (RD6 RD7) vers Terminal \r\n";
rom const char chaine3[]="Init ADC0 et ADC1\r\n";
rom const char chaine4[]="18F46K22_EDFinfo_BT_130204.c\r\n";
rom const char chaine5[]="Armement IT UART1 IT UART2\r\n ";
rom char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5 };

#pragma romdata EEP_=0xF00000

rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
      
          "Proj. 18F46K22_EDFinfo_BT_2013\r",//0  avec terminateur zero
          "Version 04/02/2013            \r",//20 avec terminateur zero
          "Init Hardware et Comm.        \r",//40  avec terminateur zero 
          "Boucle en 1 Sec   <ESC> exit  \r",//60  avec terminateur zero
          "                              \r",//80  avec terminateur zero
          "paulfjujo@free.fr        \r\n",//A0   sans terminateur zero
          "MPLAB IDE V8.89  \r\n", 
          "C18 v3.44.00   \r\n",0  
          };
#pragma romdata


#define MAX_LEN1 128
#define MAX_LEN2 176
#define MAX_LEN3 128


#pragma udata GrossBank
static unsigned char buffer[MAX_LEN1];
static unsigned char EdfInfo[MAX_LEN2];
static unsigned char Texte[MAX_LEN3];
#pragma udata

unsigned int  i,j,k,l,m;
volatile unsigned char c1,c2;
volatile int  DataReady1,DataReady2;
volatile int Index;

int LgTr;
long int Wattheure;
Word Intensite;
Word NbErr;
long DHI;

char CMD_mode;
int dummy;
char BT_state;
char response_rcvd;
char responseID, response = 0;

unsigned char *txt=&Texte[0];
unsigned char Entree[17]="1234567890123456";
unsigned char *valtxt;
Byte CRam1[32];
Byte CRam2[32];
Word EAx;

//unsigned char Drapeaux ;     // 8 flags
struct chbits {
                 unsigned Stable:1;
                 unsigned standby:1;
                 unsigned elligible:1;
                 unsigned Accumule:1;
                 unsigned Blc:1;
                 unsigned Over:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               } Drapeaux;

float f1,f2;

Byte jour, mois, An,dow, heure,min,sec ;
Byte DateTime[9];

//--- Subroutines ================
unsigned char EEPROM_Lect(unsigned char adrL) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned char adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);
//char BT_Get_Response(void); 
//void  BT_Configure(void); 
//void  Init_BT_direct(void); 
void Init_UART1(void);
int PutStrR_RS2(rom char *s);
int PutStrR_RS(rom char *s);
int PutStr_RS(char *s);
int PutStr_RS2(char *s);
void Put_RS(char * untel);
void Put_RS2(char * untel);
void CRLF(void);
void Write_Word_(unsigned int M,char Sign);
void Tempo(unsigned long val);
void  Init_Hardware(void);   
void Init_ADC(void);
unsigned int  Mesure_ADC(int canal);
void Write_Word(unsigned int M,char Sign, char remplis);
void Init_Timer1(void);
void print_flt(float W,unsigned int NbDeci);
void Init_UART2_TeleInfo(void);
void Put_RS_P2(char unCar);
int parite(unsigned char x);
void DelayTXBitUART(void);
void DelayRXHalfBitUART(void);
void DelayRXBitUART(void);
void putsUART_( char *data);  // reecriture pour exclure le Zero de fin de chaine
char LectUART(void);
unsigned char *fltToa (float x, unsigned char *str,char precision);
void Init_Timer0(void);
//------------
//   RTC DS1302  
 void write_byte( unsigned char B); 
 void write_ds1302( unsigned char B, unsigned char Data);
 unsigned char read_ds1302( unsigned char B);
 unsigned char ds1302_init(void);
 unsigned char get_bcd( unsigned char D);
 unsigned char rm_bcd( unsigned char D);
 void set_datetime( unsigned char jour, unsigned char mois,unsigned char An, unsigned char dow,unsigned char hr, unsigned min);
 unsigned char get_day(void);
 unsigned char get_mth(void);
 unsigned char get_year(void);
 unsigned char get_dow(void);
 unsigned char get_hr(void);
 unsigned char get_min(void);
 unsigned char get_sec(void);
 void DS1302_Read_Burst(void);
 void Tempor(unsigned int L1);

//------------------  
//  EEPROM du PIC
unsigned char EEPROM_Lect(unsigned char adrL) // lecture a l'adresse adrL
{	EEADR=adrL;
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(1000L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned char adrE,unsigned char car) // ecrit  a l'adresse adrE
{	EEADR= adrE;
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
}

void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(int PtrE)
{ int i;
  do
  {
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;

  Put_RS((Byte)i);
  PtrE++;
  if ( PtrE > 255) break;
   }
  while (i!=0)  ;
 Tempo(15000L);
}

//-------- interrupts---------------

void Serial_ISR(void);
 //gestionnaire d'interruption
//------------------------------
// High priority interrupt vector
#pragma code InterruptVectorHigh = 0x08
void InterruptVectorHigh (void)
{
  _asm
    goto Serial_ISR //jump to interrupt routine
  _endasm
}
#pragma code

#pragma interrupt Serial_ISR
void Serial_ISR()
 {
  static int i1=0;
  static int i2=0;  
  
 // serial 2  voir page 275 table 16-2
 // IT EDFInfo UART2 sur COM2 1200,E,7,1
 if(PIR3bits.RC2IF) // si une interruption arrive
  {
   c2 =Read2USART() & 0x7F ; // enleve la parite paire  
    if(RCSTA2bits.FERR==1 )
   {
     RCSTA2bits.SPEN = 0 ;
     RCSTA2bits.SPEN= 1 ;
     c2=0;
     DataReady2=0;
     }
   if (RCSTA2bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA2bits.CREN = 0 ;
       RCSTA2bits.CREN = 1 ;
     c2=0;
     DataReady2=0;
   } 
   if((c2 == STX) &&  (DataReady2== 0))
   {
       i2=0;
       EdfInfo[i2]=0;
       DataReady2 =1;
       c2=0;
    }
    else
     {
       if ((c2 !=EOT) && (DataReady2==1) && (i2<MAX_LEN2))
       {
         EdfInfo[i2] = c2;      
         i2++; 
         c2=0;
         DataReady2 = 1;  // trame en cours
        }
        if (c2 ==EOT)
        {
            EdfInfo[i2] = 0;         //  0 a la fin du string
            Index=i2;
            DataReady2  = 2;      // drapeau fin de trame recue
            PIE3bits.RC2IE = 0;   // disable UART2 RX interrupt 
            i2= 0;
        }    
        if (Index>=MAX_LEN2) 
         {   i2=0;
             DataReady2=3;
             PIE3bits.RC2IE = 0;   // disable UART2 RX interrupt 
        }     
     }   
    PIR3bits.RC2IF=0;      // Raz drapeau IT
  }    
    
 // Gestion IT UART1  sur  Serial com1 38400,N,8,1
  if(PIR1bits.RC1IF) // si une interruption arrive
  {
   c1 =Read1USART(); // le lire => RAZ  RCIF
  if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     RCSTA1bits.SPEN= 1 ;
     c1=0;
      }
   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       RCSTA1bits.CREN = 1 ;
     c1=0;
     } 
    if((c1 != CR) && (i1<MAX_LEN1))
   {
      buffer[i1] = c1;      
      i1++; 
      DataReady1 = 0; 
     }
     else 
      {
      buffer[i1] = 0;         //  0 a la fin du string
      DataReady1 = 1;      // drapeau Data recue
      i1=0;
    }
    PIR1bits.RC1IF=0;      // Raz drapeau IT
  }


// test si interrupt Rb0
 if (INTCONbits.INT0IF==1)
 { 
      // not used in this application
       INTCONbits.INT0IF=0;
       Put_RS('*');  Put_RS('#');
  }    // fin IT RB0

 } // fin de routine interrupt

//=============================================

void Write_Word_(unsigned int M,char Sign)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=M;
        ultoa(M1,&Entree[0]);
  }
  else itoa(M,&Entree[0]);
 if (Drapeaux.Fill)
 {
  k=strlen(Entree);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Drapeaux.Blc) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
 #ifdef LCD2x16
 if (Drapeaux.Lcd) LCD_PutRamString(valtxt); else k=PutStr_RS(valtxt);
 #else
 k=PutStr_RS(valtxt);
 #endif
}

void Init_UART1(void)
{
// USART_BRGH_HIGH,32 @ 10MHZ 
// USART_BRGH_HIGH,51 @ 16MHZ 
// USART_BRGH_HIGH,25 @ 8MHZ 
// init 19200Bd a 10Mhz avec IT en rx
// init 38400Bd a 20Mhz 
// voir para 18.5 spec sheet DS41159B page 186
Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
USART_CONT_RX &
#ifdef OSCILLATEUR_INTERNE
 USART_BRGH_HIGH,51  // 16MHz interne BRG16=0  19200bds
 // USART_BRGH_HIGH,25    // 16MHz interne BRG16=0  38400bds
#else
  USART_BRGH_HIGH,32   // Q=10Mhz 19200bds
#endif
);
}


void Init_UART2_TeleInfo(void)
{
// init 1200,E,7,1  10Mhz avec IT en rx
// voir para 18.5 spec sheet DS41159B page 186
Open2USART( USART_TX_INT_OFF &
USART_RX_INT_OFF &       // interrupt  NON armee
USART_ASYNCH_MODE &
USART_CONT_RX &
//USART_SINGLE_RX &
USART_EIGHT_BIT &        // use of 7 bits 8em bit =Parite
#ifdef OSCILLATEUR_INTERNE
USART_BRGH_LOW,207  // 16Mhz interne
#else
USART_BRGH_LOW,129   
#endif
);
}   


void Put_RS_P2(char unCar)
{ 	while(Busy2USART()); 
   	TXSTA2bits.TX9D=parite(unCar);
    TXREG2=unCar;
    }

void delay_ms(unsigned char x)
{
Delay1KTCYx(x);
Delay1KTCYx(x);
Delay1KTCYx(x);
Delay1KTCYx(x);
}


int parite(unsigned char x)
{
 unsigned char b;
   b=x;
   b ^= b >> 4;
   b ^= b >> 2;
   b ^= b >> 1;
   return b & 1;
}

int PutStrR_RS2(rom char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS2(*s);
     	}
	return n;
}

int PutStrR_RS(rom char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

int PutStr_RS2(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS2(*s);
     	}
	return n;
}

void Put_RS(char * untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}


void Put_RS2(char * untel)
{
   	while(Busy2USART());
   	Write2USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

void CRLF2()
{
  Put_RS2(CR);  Put_RS2(LF);
  }

//Tempo(2.500.000);  9.5sec avec Q=20Mhz
// Tempo(250.000);  2,2 sec avec Q=20Mhz
void Tempo(unsigned long val)
{
while(val>0){val--;}
}

void Init_ADC()
{
      //config lecture ADC 10 bits  voir page 297 DS
    ADCON0bits.ADON=1;      // ADC enabled chanel 0
    ADCON1bits.PVCFG=0;   // +Vref = +5V AVdd
    ADCON1bits.NVCFG=0;   // -Vref = Gnd AVss 
    ADCON2bits.ADFM=1;     // right justified
    ADCON2bits.ACQT2=1;
    ADCON2bits.ACQT1=1;
    ADCON2bits.ACQT0=0;    // 16 TAD
    ADCON2bits.ADCS2=1;
    ADCON2bits.ADCS1=0;
    ADCON2bits.ADCS0=1;    // Fosc/16
    //ADCON2bits.ADCS2=0;
    //ADCON2bits.ADCS1=1;
    //ADCON2bits.ADCS0=0;    // Fosc/32
  }

unsigned int  Mesure_ADC(int canal)
{ unsigned int EA;
  //ADCON0bits.ADON=1;
  ADCON0=1 + (canal<<2);   // ADON=1 et choix de canal 
  Delay10TCYx( 10 ); // Delay for 100TCY
  ConvertADC(); // Start conversion
  while( BusyADC() );
  EA = ReadADC(); // Read result
  return (EA);
}  
 // itoa( EAx,CRam);
 // Put_RS('E');Put_RS('A');Put_RS(canal+48);Put_RS('=');
 // k=PutStr_RS(CRam);
 // Tempo(5000L);
//}   


void Write_Word(unsigned int M,char Sign, char remplis)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=M;
        ultoa(M1,(char *)Entree);
  }
  else itoa(M,(char *)Entree);
  if (remplis>0)
 {
      k=strlen(Entree);
      for (i=0;i<k;i++) Entree[4-i]=Entree[k-i-1];
      for (i=0;i<(5-k);i++) Entree[i]=remplis;
  }
 Entree[5+Sign]=0;
 k=PutStr_RS(valtxt);     
}



void Init_Timer1()
{
 //--- init timer
  T1CONbits.T1CKPS1=1;
  T1CONbits.T1CKPS0=1; // prescaler =1/8
  T1CONbits.T1OSCEN=0; // Secondary Oscillator Disabled
  T1CONbits.T1SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
  T1CONbits.RD16=1 ;  // Mode 16 bits
  T1CONbits.TMR1ON=0;   // Stop timer1
  //----
 
  RCONbits.IPEN = 1;      // Enable High interrupt priority model.
  WriteTimer1(3035);      // 62500*8*4*0.1 => 200000S  =0,2sec
  PIR1bits.TMR1IF=0;      // raz flag interrupt
  IPR2bits.EEIP=0;        // low priority data eeprom write  
  IPR1bits.TMR1IP=1;      // set high priority for Timer1
  PIE1bits.TMR1IE=0;      // disable Interrupt Timer1

}


void Init_Timer0()
{
 //--- init timer0 en mode 16 bits
 //see PIC18F25K22_46K22_41412E.pdf  11.11 page 159
  T0CONbits.PSA=0;   // Timer0 prescaler assigned to Clock
  T0CONbits.T0PS2=1; //
  T0CONbits.T0PS1=1; //
  T0CONbits.T0PS0=1; // prescler =1/256
  T0CONbits.T0CS=0;     // internal cycle clock
  T0CONbits.T08BIT=0 ;  // Mode 16 bits
  //----
 //  WriteTimer0(55771);      // 256*9765*0.4 =~1sec @ 10MHz   ou 2,5sec @ 4MHz
 // WriteTimer0(61635);       // 65536-61635=3901 3900*256= 998400 S @ 4Mhz soit ~1sec
 // WriteTimer0(49900);        // @16Mhz -> 1000704S ~1sec
   WriteTimer0(40535);       // @16Mhz 1,6sec

  INTCONbits.TMR0IF=0;      // raz flag interrupt
  INTCONbits.TMR0IE=0;    // enable interupt Peripheriques
  T0CONbits.TMR0ON=0;     // Stop Timer0 OFF
}


void Init_Hardware()
 {   

   PMD0bits.UART1MD=0;  // USART1 enable
   PMD0bits.UART2MD=0;  // USART2 enable
   PMD0bits.TMR6MD=1;   // Timer6 disable
   PMD0bits.TMR5MD=1;   // Timer5 disable
   PMD0bits.TMR4MD=1;   // Timer4 disable
   PMD0bits.TMR3MD=1;   // Timer3 disable
   PMD0bits.TMR2MD=1;   // Timer2 disable
   PMD0bits.TMR1MD=0;   // Timer1 Enable
  
   PMD1bits.MSSP2MD=1;   // MSSP2 disabled
   PMD1bits.MSSP1MD=1;   // MSSP1 disabled
   PMD1bits.CCP5MD=1;   // Disabled
   PMD1bits.CCP4MD=1;   // Disabled
   PMD1bits.CCP3MD=1;   // Disabled
   PMD1bits.CCP2MD=1;   // Disabled
   PMD1bits.CCP1MD=1;   // Disabled

   PMD2bits.CTMUMD=1;   // Disabled
   PMD2bits.CMP2MD=1;   // Disabled   
   PMD2bits.CMP1MD=1;   // Disabled      
   PMD2bits.ADCMD=0;    // Enable      
              
   PORTB = 0xFF;
   ANSELB=0;             // No analog input,PortB digital 
   TRISB = 0b11101101;   // config portb pins
   TRISBbits.TRISB0=1;   	// B0 <- IR input
   TRISBbits.TRISB1=1;   	// B1 not used
   TRISBbits.TRISB2=1;   	// B2 not used
   TRISBbits.TRISB3=1;		// B3 not used
   TRISBbits.TRISB4=1;		// B4 TX softuart set as input even UART is output see p268
   TRISBbits.TRISB5=1;		// B5 Rx soft Uart
   TRISBbits.TRISB6=1;      //  B6 not used  ICSP bleu clair  UART2  TX -->
   TRISBbits.TRISB7=1;      //  B7 not used  ICSP bleu fc    <-- RX UART2

  // ATTENTION a l'ordre des canaux ANALOGIQUES !!!

   ANSELA=0;   
   PORTA = 0xFF;
   ANSELAbits.ANSA0=1;   //  RA0 analog input on Port A   voir page 154
   ANSELAbits.ANSA1=1;   // RA1  RA0 analog input
   TRISA = 0b00001111 ;  // PORTA is RA0,RA1= analog input, RA2,RA3=input RA4,RA5=Digital output
   TRISAbits.TRISA0=1;   	// A0 Analog input
   TRISAbits.TRISA1=1;   	// A1 Analog input
   TRISAbits.TRISA2=1;   	// A2 input     info pompe
   TRISAbits.TRISA3=1;		// A3 input     info Chauffage
   TRISAbits.TRISA4=0;		// A4 output    led rouge
   TRISAbits.TRISA5=1;		// A5 intput    Quality_link_test
   TRISAbits.TRISA6=1;      // A6 clock Quartz ou libre si oscill interne
   TRISAbits.TRISA7=1;      // A7 clock quartz ou libre si oscill interne

  PORTC = 0xFF;          // set PORTC to $FF
  ANSELC=0; 
  TRISC = 0b10000000;    // all output expect RC7
  TRISCbits.TRISC0 = 0;
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 0;
  TRISCbits.TRISC3 = 0; // RTC DS1302 SCLK
  TRISCbits.TRISC4 = 0; // RTC DS1302 data RTC_IO 
  TRISCbits.TRISC5 = 0; // RTC DS1302 RTC_RST
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader
  
   // all inputs
  ANSELD=0;
  TRISD=0xFF;  
  TRISDbits.TRISD0=1;   //  not used 
  TRISDbits.TRISD1=1;   //  not used
  TRISDbits.TRISD2=1;   //  not used
  TRISDbits.TRISD3=1;	//  not used
  TRISDbits.TRISD4=1;	//  not used
  TRISDbits.TRISD5=1;	//  not used
  TRISDbits.TRISD6=1;   //  D6  UART2  TX -->
  TRISDbits.TRISD7=1;   //  D7  <-- RX UART2 
            
  ANSELE=0;
  PORTE=0x00;
  TRISE=0x07;   // RE0,RE1,RE2 as input

  RCONbits.IPEN=1   ; // enable priority levels
  RCONbits.SBOREN=0;  //  BOR disbled
  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }
 
 
 unsigned char *fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }

// in f format, number of digits is related to size 
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ... 
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;					
if (x >= 10.0) {x = 1.0; ie++;} 
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);	
  x *= 10.0;	
  }
*str = '\0';
return (adpt);
}
 
 void print_flt(float W,unsigned int NbDeci)
// 4 decimales maxi car NbDeci=10.000 max
{unsigned long lWhole;
 unsigned int ulPart;
 switch (NbDeci)
 {
 case 1: break;
 case 10:break;
 case 100:break;
 case 1000:break;
 case 10000:break;
 default:
 {
     CRLF();
     strcpypgm2ram((char *)CRam1, "Error Nb decimales");
   	 k=PutStr_RS((char *)CRam1);
   	 CRLF();
   	 return;
 }
 }
 lWhole=(long)(W);
 ulPart=(unsigned int)((W*(float)NbDeci)-(float)(lWhole*NbDeci));
 ultoa(lWhole,(char *)Entree);
 k=PutStr_RS(Entree);
 Put_RS('.');
 Write_Word(ulPart,0,0);      
}


void MAJ_RTC()
{
     m=2; // passe par dessus U;
     j=0;
     PIE1bits.RCIE = 0;
     l=strlen(buffer);
     #ifdef Debugging 
     k=fprintf(_H_USART,"\n\rMise a l'heure de %03d cars =%s  buffer{0)=%c   Buffer[l-1]=%c\n\r",l,buffer,buffer[0],buffer[l-1]); 
     #endif    
     if ((buffer[0]=='U')&& (buffer[l-1]=='#') && (l<21))
     {
        k=fprintf(_H_USART,"\n\rMise a l'heure : %s   %2d cars\n\r",buffer,l);      
         for (i=2;i<l;i++)
          { if(buffer[i]==';')
              { 
                buffer[i]=0;    
                #ifdef Debugging 
                k=fprintf(_H_USART,"%s%c",buffer+m,TAB);
                #endif
                DateTime[j]=atoi(buffer+m);
                 #ifdef Debugging 
                 k=fprintf(_H_USART,"DateTime[%1d]=%02d\n\r",j,DateTime[j]);
                 #endif
                m=i+1;
                j++;
              } 
          }// for i 
       // ne pas oublier le dernier! 
        buffer[l-1]=0; // elimine # en fin de chaine
        #ifdef Debugging 
        k=fprintf(_H_USART,"%s%c",buffer+m,TAB);      
        #endif
        DateTime[j]=atoi(buffer+m);
        #ifdef Debugging 
         k=fprintf(_H_USART,"DateTime[%1d]=%02d\n\r",j,DateTime[j]);      
        #endif
        min=DateTime[5];
        heure=DateTime[4];
        jour=DateTime[0];
        mois=DateTime[1];
        An=DateTime[2];
        dow=DateTime[3];
        set_datetime( jour,mois,An,dow,heure,min);    
        /*
        write_ds1302(0x80,0);
        write_ds1302(0x82,get_bcd(DateTime[5]));//min
        write_ds1302(0x84,get_bcd(DateTime[4]));//Heur
        write_ds1302(0x86,get_bcd(DateTime[0]));//jour
        write_ds1302(0x88,get_bcd(DateTime[1]));// mois
        write_ds1302(0x8C,get_bcd(DateTime[2]));//annee
        write_ds1302(0x8A,get_bcd(DateTime[3]));//jsem
        */
        
        buffer[0]=0;
        j=0;
        NbErr=0;
        DataReady1 =0;
        PIE1bits.RCIE = 1;
     }// if buffer[0]='U'
 }   



 
void main() 
{

Init_Hardware();                  
  
#ifdef OSCILLATEUR_INTERNE
    OSCCON=0b01110010;   // 16MHz interne
    OSCCON2=0b00000100;  // Primary oscillator ON
    OSCTUNEbits.PLLEN=0; // PLL disabled
#endif
    
  Drapeaux.Fill=1;
  Drapeaux.Blc=1;

  c1 = 0;
  DataReady1 = 0;
  buffer[0]=0;
  Init_UART1();         // 19200 bds at 10MHz
  
  OUT_RS232
  while(DataRdy1USART())
  {
  c1=getc1USART();
  }
  c1=0;
  Put_RS(CLS);  
  Tempo(100000);
  txt=&Texte[0];
  strcpypgm2ram(txt,RS_Str[1]);    
  k=PutStr_RS(txt);              
  
   c2 = 0;
  DataReady2= 0;
  EdfInfo[0]=0;
  Init_UART2_TeleInfo();
  Tempo(100000);
  txt=&Texte[0];
  dummy=PutStrR_RS(RS_Str[2]);      // direct print string en ROM
  
   
  PrintOut_Eeprom_Msg(0x00); // projet ..
  PrintOut_Eeprom_Msg(0x20); // version ...
  
  Init_ADC();
  
  // timer 0 not yet used 
  Init_Timer0();
  INTCONbits.TMR0IE=0;
  INTCONbits.TMR0IF=0;
  T0CONbits.TMR0ON=0;

  dummy=PutStrR_RS("MyBT-DB49 Connecting via BT with BlueSoleil PC  ");
  Init_BT_direct();
  txt=&Texte[0];
  dummy=PutStrR_RS("...Connected!");   //  Send message on connection
  Put_RS(13);              // CR
  
  j=ds1302_init();

 // mise a jour par defaut si Force_RTC=1
 // set_datetime(jour, mois,An,dow,hr,min)  sec set to 0
  if (Force_RTC==1)
  {
    set_datetime( 31, 1, 13, 4, 17,59);    // merc 30 janv 2013 17H59     
    k=fprintf(_H_USART," Init DS1302 par defaut au 31 janvier 2013 mercredi ,17H59\n\r");
   }
  
  txt=&Texte[0];
  strcpypgm2ram(txt,RS_Str[5]);  // armement IT 
  k=PutStr_RS(txt);  
  CRLF();
  
  DataReady1 = 0;         // Data not received
  DataReady2 = 0;
   
  // UART1 
  RCSTA1bits.CREN = 1 ;
  PIE1bits.RCIE = 1;        // enable Interrupt on receive uART1
  IPR1bits.RC1IP=1;     // high priority level
  
  PIE3bits.RC2IE = 1;   // Enable UART2 RX interrupt 
  IPR3bits.RC2IP=1;     // high priority level
  RCONbits.IPEN = 1;    // Enable High interrupt priority model.
  INTCONbits.PEIE = 1;  // autorisation des IT des priphriques
  INTCONbits.GIE = 1 ;  // autorisation globale des IT

  //=============  Main Boucle ========================
  j=0;            
  NbErr=0;     
  while (1) 
  {
    Write_Word_(j,0); // valeur de j, compteur de boucle principale
    Put_RS(TAB);
 
  #ifdef LCD2x16
    OUT_LCD
    LCD_Erase_Ligne(1);
    LCD_PutRomString("Envoi :"); 
    LCD_Pos(1,8); Write_Word_(j,0);
    LCD_Erase_Ligne(2);
    i=0;
    while (buffer[i] != 0) 
    {
      LCD_Put(buffer[i]);       // Displaying the received text on the LCD
      i++;                      // Increment counter
    }
   #endif  
   OUT_RS232
   
    sec=get_sec();
    min=get_min();
    heure=get_hr();
    jour=get_day();
    // mois=get_mth();
    //An= get_year();
    k=fprintf(_H_USART,"%02d %02d/%02d/%02d  ; ",jour,heure,min,sec); 
    k=fprintf(_H_USART,"Ppe= %1d ; ",Pompe);
	k=fprintf(_H_USART,"Chauf= %1d% ;",Chauffage);
	EAx=Mesure_ADC(0);
	//TInt LM335 2730mV at 0C:
   	f1=(float) EAx*0.48828125-273.0;
   	k=fprintf(_H_USART,"TInt:%4d  %sC ;",EAx,fltToa(f1,CRam1,2));
    //T Ext LM35DZ 0mV at 0C
    EAx=Mesure_ADC(1);
   	f2=(float)EAx*500/1024; 
    k=fprintf(_H_USART,"TExt:%4d  %sC ; ",EAx,fltToa(f2,CRam1,2));
    
    Led_Rouge=1; // eteint car rappel au +5V
   // boucle principale cale sur l'arrivee trame EDF ou Timeout Timer0
    // Attente de l' arrive d'une Trame EDF complete  detect par les Caracteres STX puis EOF
    // arme timer0 sur delai inter trame maxi defini ici  a 1,6sec
    INTCONbits.TMR0IF=0;
    WriteTimer0(40535);   // 1,6sec  49900 -> 1sec at 16Mhz
    T0CONbits.TMR0ON=1;  
    
    
    // mise a l'heure par clavier UART1 com1 38400,N,8,1
    // sequence attendue  U;JJ;MM,AA,JS;HH;MN#   20 cars   (secondes forcees a 00)
    // macro sur touche vbray : U;29;10;50;4;18;33#035#013
    #define Debugging 
    if ( DataReady1 == 1) MAJ_RTC();
    
    // et la reconnaissance des items BASE et IINST contenus dans la trame
    // permet d'extirper les valeurs numeriques ascii  
    LgTr=0;
    while ((DataReady2<2)&&(INTCONbits.TMR0IF==0));
    
     if(INTCONbits.TMR0IF==1) 
     {
         k=fprintf(_H_USART,"TimeOut Trame EDF");
         T0CONbits.TMR0ON=0;
         NbErr++;
      }
      else
     {    
         if (DataReady2==2)  // c'est une trame entiere !
         {
            INTCONbits.GIE = 0; 
            Led_Rouge=0; // eteint car rappel au +5V
            // check longuer de trame (toujours identhique !)  = 116 avec script VBRAY 
            LgTr=strlen(EdfInfo); 
            //k=fprintf(_H_USART,"LgTR=%03d ;",LgTr);  
            if (LgTr==116)
            {   
             // pour debugging
             // CRLF();
             // PutStr_RS(&EdfInfo[0]); // renvoi sur PC terminal UART1
             // CRLF();   
             // recherche BASE conso en Wh  
              for (i=40;i<Index;i++)
              {               
                if (*(EdfInfo+i)=='B' && *(EdfInfo+i+3)=='E' )
                {
                *(EdfInfo+i+15)=0;
                // pour verif capture 
                //  k= PutStr_RS(EdfInfo+i);
                strcpy(CRam1,EdfInfo+i+4);
                Wattheure=atol((char *)CRam1);
                k=fprintf(_H_USART," %9lu WH ; ",Wattheure);
                i=i+16;
                }
                // recherche I INSTantane 
                if (*(EdfInfo+i)=='I' && *(EdfInfo+i+1)=='I' && *(EdfInfo+i+4)=='T' )
                {
                *(EdfInfo+i+9)=0;
                // pour verif capture  
                //  k= PutStr_RS(buffer+i);
                strcpy(CRam2,EdfInfo+i+6);
                Intensite=atoi((char *)CRam2);
                k=fprintf(_H_USART," %3d Amp",Intensite);
                break;
                }
              }// for I=40   
            } // if lg trame ok
            else 
            {
                NbErr++;
               EdfInfo[0]=0;
                DataReady2=0;
                
            } // if Trame =116  
          } // if DataReady==2 trame complete  
          if (DataReady2==3) 
          {
            CRLF();
            k=fprintf(_H_USART,"Overflow EdfInfo : %5d ",Index);   
            NbErr++;
             NbErr++;
             EdfInfo[0]=0;
              DataReady2=0;
           }     
     }// else if timer0 IF 
       j++;
     // qualite de transmission en % reactualisee toute les 100 trames ou 160sec
     if (Quality_link_test==0)
      {
          if (j>99)
          {
          // f2=(float)NbErr*100.0/(float)j;
           l=(NbErr*100) /j;
           //l=fprintf(_H_USART,"Taux Err = %s",fltToa(f2,CRam1,2));
           if (l==0)k=fprintf(_H_USART," OK"); else  k=fprintf(_H_USART," ERR= % 3d%",l);
           j=0;NbErr=0;
          } 
          
      }
      else
      {
      NbErr=0;
      } // quality
        
      EdfInfo[0]=0; 
      Index=0;
      CRLF();
      c2 =Read2USART() ; // vide buffer
      DataReady2=0;
      PIR3bits.RC2IF=0;    // Raz drapeau IT UART2
      PIE3bits.RC2IE =1;   //enable UART2 RX interrupt
      INTCONbits.GIE = 1; 
 
  
  } // while    
}

/*
Port Hard UART1 19200,N,8,1 (RC6 RC7_ -> BT RN41 
Port Hard UART2 EDF info 1200,E,N,7,1 (RD6 RD7) vers Terminal 
Proj. 18F46K22_EDFinfo_BT_2013
Version 04/02/2013            
MyBT-DB49 Connecting via BT with BlueSoleil PC  $$$
+
SN,MyBT-DB49
SU,19.2
SM,0
SA,1
SP,1234
---
...Connected!
Armement IT UART1 IT UART2
 
00000	04 16/04/32  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; TimeOut Trame EDF
00001	04 16/04/34  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; TimeOut Trame EDF
00002	04 16/04/36  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; TimeOut Trame EDF
00003	04 16/04/37  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; TimeOut Trame EDF
00004	04 16/04/39  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; TimeOut Trame EDF
00005	04 16/04/41  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; TimeOut Trame EDF
00006	04 16/04/42  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ; 
00007	04 16/04/43  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    1 Amp
00008	04 16/04/44  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    2 Amp
00009	04 16/04/45  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    3 Amp
00010	04 16/04/46  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    4 Amp
00011	04 16/04/47  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    5 Amp
00012	04 16/04/48  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    6 Amp
00013	04 16/04/49  ; Ppe= 0 ; Chauf= 0TInt: 600  19.97C ;TExt:  40  19.53C ;   39229704 WH ;    7 Amp
*/
/*
----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.mcp' started.
Language tool versions: mpasmwin.exe v5.47, mplink.exe v4.45, mcc18.exe v3.44, mplib.exe v4.45
Mon Feb 04 16:03:31 2013
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.cof".
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.hex".
Clean: Done.
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F46K22 /i"C:\_C18\_MesProjets_C18\_18F46K22" -I"C:\Program Files\Microchip\mplabc18\h" "18F46K22_EDFinfo_BT_130204.c" -fo="C:\_C18\tmp\18F46K22_EDFinfo_BT_130204.o" -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa- -nw=2054 -pa=3 -nw=2066
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_130204.c:1135:Warning [2058] call of function without prototype
Executing: "C:\Program Files\Microchip\mplabc18\bin\mplink.exe" /p18F46K22 /l"C:\Program Files\Microchip\mplabc18\lib" /k"C:\_C18\_MesProjets_C18\_common" /k"C:\Program Files\Microchip\mplabc18\bin\LKR" "..\_common\18f46k22_GrosseBank.lkr" "..\..\tmp\18F46K22_EDFinfo_BT_130204.o" /u_CRUNTIME /z__MPLAB_BUILD=1 /o"C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.cof" /M"C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.map" /W
MPLINK 4.45, Linker
Device Database Version 1.10
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

MP2HEX 4.45, COFF to HEX File Converter
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.cof.
----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_EDFinfo_BT_2013.mcp' succeeded.
Language tool versions: mpasmwin.exe v5.47, mplink.exe v4.45, mcc18.exe v3.44, mplib.exe v4.45
Mon Feb 04 16:03:37 2013
----------------------------------------------------------------------
BUILD SUCCEEDED
*/
/*
program teleinfo;
// voir Telefinfo_log_trame_hexadecimal.jpg
// space et checksum deja inclus dans la chaine ascii
// longueur de trame=116
// rev 03 fev 2013
var datum: string;
var i: integer;
var j: integer;
var k: integer;
var str: string;
var checksum : char ;

//
begin
ShowMessage('Simulate EDF Trame info to PIC18F46K22 using COM2'+chr(10)+chr(13)+ '* Send to PIC UART2 1200,E,7,1 ' +chr(10)+chr(13)+ '* Get back results on other Vbray from UART1 COM1 38400,8,N,1'+chr(10)+chr(13));
Delay(1500);
begin
j:=0;
  i:=0;
  while (j<1000) do
   begin  // boucle en environ 1 seconde
	// checksum pour 000 => 87 
     checksum :=chr(i+87);
     str:= 'IINST 00' + chr(i+48) + chr(20) + checksum;
	ComSendChr(2);	//STX
	ComSendChr(10); // LF
	ComSendStr('ADCO 04983');ComSendChr(13);
        ComSendChr(10);ComSendStr('OPTARIF BASE 0');ComSendChr(13);
	ComSendChr(10);ComSendStr('ISOUSC 30 9');ComSendChr(13);
	ComSendChr(10);ComSendStr('BASE 039229704 /');ComSendChr(13);
	ComSendChr(10);ComSendStr('PTEC TH.. $');ComSendChr(13);
	ComSendChr(10);ComSendStr(str);ComSendChr(13);
	ComSendChr(10);ComSendStr('IMAX 023 D');ComSendChr(13);
	ComSendChr(10);ComSendStr('MOTDETAT 000000 B');ComSendChr(13);
      ComSendChr(3); //EOT
     i:= i+1;
     if i>9 then i:=0;
    j:=j+1;
  Delay(50);
  end;
end;
end.
*/
//ADCO 04983
//OPTARIF BASE 0
//ISOUSC 30 9
//BASE 039229704 /
//PTEC TH.. $
//IINST 000W
//IMAX 023 D
//MOTDETAT 000000 B

